import { world, system } from '@minecraft/server'
import * as ui from '@minecraft/server-ui'
let cinecam = { enabled: {} }

let manual = new ui.ActionFormData
manual.body('Cinecam adds cinematic cameras from Java Edition. Cinecam uses > as a command prefix. The only command is >cinecam. Arguments: \n launch - starts the cinematic camera \n stop - stops the cinematic camera \n (optional, after launch) Strength - Value from 0.25 - 5. \n (optional, before strength) --nolimit - removes the limit of strength \n (optional, after strength) --walk - makes you able to move while in cinematic mode')
manual.button('Close')

world.beforeEvents.chatSend.subscribe(eventData => {
    let player = eventData.sender
    let player_name = eventData.sender.nameTag
    let message = eventData.message
    let args = eventData.message.split(' ')
    if (message[0] == '>') {
        if (args[0] == '>cinecam') {
            eventData.cancel = true
            if (args[1] == 'launch') {
                if (args.length > 5) {
                    player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cToo many arguments!"}]}')
                    return
                }
                let speed = '1'
                let zoom_factor = '0'
                let able_to_walk = false
                if (args[2] == undefined) {
                    speed = '1'
                }
                else {
                    if (args[2] == '--nolimit') {
                        speed = parseFloat(args[3])
                        if (args[4] == '--walk' && args[4] != undefined) {
                            able_to_walk = true
                        }
                    }
                    else {
                        speed = parseFloat(args[2])
                        if (!(speed >= 0.25 && speed <= 5.00)) {
                            player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cStrength needs to be more or equal to§a 0.25 §cand less or equal to§a 5§r.§§§aBig number = Slow, more cinematic§r. Default value is §a1."}]}')
                            return
                        }
                        if (args[3] == '--walk' && args[3] != undefined) {
                            able_to_walk = true
                        }
                    }
                }
                //                if (args[3] == '--beta' && args[3] != undefined) {
                //                    if (args[4] == undefined) {
                //                        player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cNot enough arguments!"}]}')
                //                        return
                //                    }
                //                }
                //                else {
                //                    player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cUnknown argument!"}]}')
                //               }
                cinecam.enabled[player_name] = true
                player.runCommandAsync(`title @s title §aCineCam started!`)
                let loop = system.runInterval(() => {
                    player.runCommandAsync(`camera @s set minecraft:free ease ${speed} linear pos ~~1.7~ rot ~~`)
                    player.runCommandAsync(`effect @s invisibility 1 1 true`)
                    if (!able_to_walk) player.runCommandAsync(`effect @s slowness 1 8 true`)
                    if (cinecam.enabled[player_name] == false) {
                        system.clearRun(loop)

                        player.runCommandAsync(`camera @s clear`)
                    }
                }, 1)
            }
            if (args[1] == undefined) {
                player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cNot enough arguments!"}]}')
                return
            }
            else if (args[1] != 'stop' && args[1] != 'launch' && args[1] != 'help' && args[1] != undefined) {
                player.runCommandAsync('tellraw @s {"rawtext":[{"text":"§cUnknown argument!"}]}')
                return
            }

        }
    }
})

world.beforeEvents.chatSend.subscribe(eventData => {
    let player = eventData.sender
    let player_name = eventData.sender.nameTag
    let message = eventData.message
    let args = eventData.message.split(' ')
    if (message[0] == '>') {
        if (args[0] == '>cinecam') {
            if (args[1] == 'stop') {
                cinecam.enabled[player_name] = false
                player.runCommandAsync(`title @s title §cStopping...`)
                let cd = { time_left: {} }
                cd.time_left[player_name] = Date.now() + 1000
                let cdloop = system.runInterval(() => {
                    if (cd.time_left[player_name] <= Date.now()) {
                        player.runCommandAsync(`camera @s clear`)
                        player.runCommandAsync(`title @s subtitle §aDone!`)
                        system.clearRun(cdloop)
                    }
                }, 1)
            }
        }
    }

})

world.beforeEvents.chatSend.subscribe(eventData => {
    let player = eventData.sender
    let player_name = eventData.sender.nameTag
    let message = eventData.message
    let args = eventData.message.split(' ')
    if (message[0] == '>') {
        if (args[0] == '>cinecam') {
            if (args[1] == 'help') {
                system.run(() => {
                    let cd = { time_left: {} }
                    player.runCommandAsync('tellraw @s {"rawtext":[{"text":"Manual will be open in 5 seconds, close the chat!"}]}')
                    cd.time_left[player_name] = Date.now() + 5000
                    let cdloop = system.runInterval(() => {
                        if (cd.time_left[player_name] <= Date.now()) {
                            manual.show(player)
                            system.clearRun(cdloop)
                        }
                    }, 1)

                })
            }
        }
    }

})